close all

% generator 2
primarycontrolled.p(tnindex(primarycontrolled.pnames, 'Controller.up_limit0')) = 0;

% ultc
primarycontrolled.p(tnindex(primarycontrolled.pnames, 'Controller.tappos0')) = 1;   % where nT = T1.tappos*T1.TapStep + 1
primarycontrolled.p(tnindex(primarycontrolled.pnames, 'Controller.timer0')) = -15;
primarycontrolled.p(tnindex(primarycontrolled.pnames, 'Controller.idle0')) = 1;
primarycontrolled.p(tnindex(primarycontrolled.pnames, 'Controller.wait0')) = 0;
primarycontrolled.p(tnindex(primarycontrolled.pnames, 'Controller.action0')) = 0;

% load
primarycontrolled.p(tnindex(primarycontrolled.pnames, 'System.Load.xp0')) = 0;
primarycontrolled.p(tnindex(primarycontrolled.pnames, 'System.Load.xq0')) = 0;


Mod_Options = simset('OutputPoints', 'all');
Mod_Options = simset(Mod_Options, 'SaveFormat', 'StructureWithTime');



ut_ok = [     0    0.9850    2.0000         0         0;
    10.0000    0.9850    2.0000         0         0;
    20.0000    0.9850    2.0000         0         0;
    80.0000    0.9850    2.0000         0         0;
    90.0000    1.0350    2.0000         0         0;
    120.0000    1.0350    2.0000         0         0;
    200.0000    1.0350    2.0000         0         0;
    200.001     1.0350    2.0000         0        1;
    500.0000    1.0350    2.0000         0        1];


ut = [
    0        2   0   1 0   ;
    100      2   0   1 1  ;
    100.01   2   0   1 1  ;
    200.01   2   0   1 1  ;    
]

sim('test_mod_x0', 0:380, Mod_Options);

figure(1); clf; hold on;
subplot(311); hold on;
plot(Vm_mod.time, Vm_mod.signals.values(:,3))
stairs(ut(:,1), ut(:,4)-0.015, 'y');
stairs(ut(:,1), ut(:,4)+0.015, 'y');
subplot(312)
plot(aux_mod.time, aux_mod.signals.values(:, 28))
subplot(313)
plot(aux_mod.time, aux_mod.signals.values(:, 31:33))



figure(2)

% test 2 - fragmented simulation
Vm_mod_ref=Vm_mod;
aux_mod_ref=aux_mod;
Efd_mod_ref=Efd_mod;

tv=[]; Vmv=[];auxv=[];Efdv=[];
simstep=1.001;tstop=380  % be careful so you do not use exact numbers like 1 sec or so
                          % if simulation stops/restarts exactly at event instants
                          % the correct behaviour cannot really be defined if simulation
                          % is restarted exactly at the event instants

for k=0:simstep:(tstop-simstep)
    try
        sim('test_mod_x0', k+[0 simstep], Mod_Options);
        zfinal=aux_mod.signals.values(size(aux_mod.signals.values,1),primarycontrolled.z_ind)'
        xfinal=aux_mod.signals.values(size(aux_mod.signals.values,1),primarycontrolled.x_ind)'
        primarycontrolled.p(primarycontrolled.z0_ind)=zfinal;
        primarycontrolled.p(primarycontrolled.x0_ind)=xfinal;
        tv=[tv; Vm_mod.time];  
        Vmv=[Vmv; Vm_mod.signals.values];
        Efdv = [Efdv; Efd_mod.signals.values(:,1)];
        auxv=[auxv; aux_mod.signals.values];
    catch
        disp(lasterr);
        error(['Error in simulation : ' num2str(k)])
    end
end

subplot(211)
plot(Vm_mod_ref.time,Vm_mod_ref.signals.values(:,3),':')
subplot(212)
plot(tv,Vmv(:,3))

figure(3)
plot(tv,Efdv(:,1),Efd_mod_ref.time, Efd_mod_ref.signals.values(:, 1),':')