function i = tnindex(n,name)
%tnindex  get row-index of string in trajectory-name matrix
%
%         tnindex(n,name) returns the row number of the string matrix "n",
%         if the string "name" is identical to row i. If "name" does not
%         match a row of "n", i=0. Example:
%
%             n = [ 'signal1'
%                   'signal2'
%                   'signal3' ];
%
%             i = tnindex(n,'signal2')  --> returns i=2
%             i = tnindex(n,'signal')   --> returns i=1 
%             i = tnindex(n,'sigz')     --> returns i=0
%
%See also: traj, dymosim, tload, tnlist, tplot, tplotm, tsame, tsave
%

%    Copyright (c) 1995,1996,1997 by DLR.
%    Copyright (C) 1997-2001 Dynasim AB.
%    All rights reserved.

if nargin < 2
   error('tnindex requires 2 arguments')
end

nrow = size(n,1);
ncol = min( size(n,2), size(name,2) );
i = 0;
for j=1:nrow
   if name(1,1:ncol) == n(j,1:ncol)
      n2=[n(j,:),' '];
      if n2(1,ncol+1)<=' '
        i = j;
        break
      end
   end
end
